; IPC5 Domain: TPP Metric
; Authors: Alfonso Gerevini and Alessandro Saetti 

(define (domain TPPLike-Metric)
(:requirements :typing :fluents) 
(:types depot market - place 
	truck goods - locatable)

(:predicates (at ?t - truck ?p - place)
	     (on-sale ?g - goods ?m - market)
	     (available ?g - goods ?m - market)
             (loaded ?g - goods ?t - truck)
	     (stored ?g - goods)
)

(:functions (drive-cost ?p1 ?p2 - place)
	    (price ?g - goods ?m - market)
	    (total-cost)
	    (money))

(:action drive
 :parameters (?t - truck ?from ?to - place)
 :precondition (and (at ?t ?from) 
                    (>= (money) (drive-cost ?from ?to)))
 :effect (and (not (at ?t ?from)) (at ?t ?to)
	      (increase (total-cost) (drive-cost ?from ?to))
	      (decrease (money) (drive-cost ?from ?to))))

(:action buy
 :parameters (?t - truck ?g - goods ?m - market)
 :precondition (and (on-sale ?g ?m)
		    (>= (money) (price ?g ?m)))
 :effect (and (not (on-sale ?g ?m)) (available ?g ?m)
	      (increase (total-cost) (price ?g ?m))
	      (decrease (money) (price ?g ?m))))

(:action load
 :parameters (?g - goods ?t - truck ?m - market)
 :precondition (and (available ?g ?m) (at ?t ?m))
 :effect (and (loaded ?g ?t) (not (available ?g ?m))))

(:action unload
 :parameters (?t - truck ?g - goods ?d - depot)
 :precondition (and (loaded ?g ?t) (at ?t ?d))
 :effect (and (stored ?g) (not (loaded ?g ?t))))
)
